Bug 1897500 - python-apsw fails to build with Python 3.10: Avoid using PyObject_AsCharBuffer(), PyObject_AsReadBuffer() and PyObject_AsWriteBuffer()
Summary: python-apsw fails to build with Python 3.10: Avoid using PyObject_AsCharBuffe...
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: python-apsw
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Denis Fateyev
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-13 08:38 UTC by Tomáš Hrnčiar
Modified: 2021-02-09 16:23 UTC (History)
5 users (show)

Fixed In Version: python-apsw-3.34.0.r1-1.fc33
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-12-29 01:17:45 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github rogerbinns apsw issues 301 0 None open deprecated buffer protocol API 2021-01-21 16:59:43 UTC

Description Tomáš Hrnčiar 2020-11-13 08:38:27 UTC
python-apsw fails to build with Python 3.10.0a2.

Traceback (most recent call last):
  File "/builddir/build/BUILD/apsw-3.33.0-r1/setup.py", line 907, in <module>
    setup(name="apsw",
  File "/usr/lib/python3.10/site-packages/setuptools/__init__.py", line 153, in setup
    return distutils.core.setup(**attrs)
  File "/usr/lib64/python3.10/distutils/core.py", line 148, in setup
    dist.run_commands()
  File "/usr/lib64/python3.10/distutils/dist.py", line 966, in run_commands
    self.run_command(cmd)
  File "/usr/lib64/python3.10/distutils/dist.py", line 985, in run_command
    cmd_obj.run()
  File "/builddir/build/BUILD/apsw-3.33.0-r1/setup.py", line 130, in run
    import tests
  File "/builddir/build/BUILD/apsw-3.33.0-r1/tests.py", line 9, in <module>
    import apsw
ImportError: /builddir/build/BUILDROOT/python-apsw-3.33.0.r1-1.fc34.x86_64/usr/lib64/python3.10/site-packages/apsw.cpython-310-x86_64-linux-gnu.so: undefined symbol: PyObject_AsWriteBuffer

https://docs.python.org/3.10/whatsnew/changelog.html#id16

bpo-41103: PyObject_AsCharBuffer(), PyObject_AsReadBuffer(), PyObject_CheckReadBuffer(), and PyObject_AsWriteBuffer() are removed. Please migrate to new buffer protocol; PyObject_GetBuffer() and PyBuffer_Release().

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01757291-python-apsw/

For all our attempts to build python-apsw with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-apsw/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Fedora Update System 2020-12-20 22:30:59 UTC
FEDORA-2020-9b9107b8e0 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2020-9b9107b8e0

Comment 2 Fedora Update System 2020-12-21 02:24:19 UTC
FEDORA-2020-9b9107b8e0 has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-9b9107b8e0`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-9b9107b8e0

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 3 Fedora Update System 2020-12-29 01:17:45 UTC
FEDORA-2020-9b9107b8e0 has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 4 Tomáš Hrnčiar 2021-01-05 08:46:30 UTC
I am reopening this since python-apsw still doesn't build with Python 3.10

Traceback (most recent call last):
  File "/builddir/build/BUILD/apsw-3.34.0-r1/setup.py", line 908, in <module>
    setup(name="apsw",
  File "/usr/lib/python3.10/site-packages/setuptools/__init__.py", line 153, in setup
    return distutils.core.setup(**attrs)
  File "/usr/lib64/python3.10/distutils/core.py", line 148, in setup
    dist.run_commands()
  File "/usr/lib64/python3.10/distutils/dist.py", line 966, in run_commands
    self.run_command(cmd)
  File "/usr/lib64/python3.10/distutils/dist.py", line 985, in run_command
    cmd_obj.run()
  File "/builddir/build/BUILD/apsw-3.34.0-r1/setup.py", line 130, in run
    import tests
  File "/builddir/build/BUILD/apsw-3.34.0-r1/tests.py", line 9, in <module>
    import apsw
ImportError: /builddir/build/BUILDROOT/python-apsw-3.34.0.r1-1.fc34.x86_64/usr/lib64/python3.10/site-packages/apsw.cpython-310-x86_64-linux-gnu.so: undefined symbol: PyObject_AsWriteBuffer

Full log: https://download.copr.fedorainfracloud.org/results/@python/python3.10/fedora-rawhide-x86_64/01854954-python-apsw/builder-live.log.gz

Comment 5 Ben Cotton 2021-02-09 15:24:02 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.


Note You need to log in before you can comment on or make changes to this bug.